﻿namespace BukiVedi.Shared.Entities
{
    /// <summary>
    /// Книга
    /// </summary>
    public sealed class Book
        : BaseEntity
    {
        /// <summary>
        /// Название книги
        /// </summary>
        public string Title { get; set; }
        /// <summary>
        /// Описание книги
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        /// Жанры книги
        /// </summary>
        public string GenreId { get; set; }
        /// <summary>
        /// Авторы
        /// </summary>
        public List<string> AuthorIds { get; set; }
        /// <summary>
        /// Формат
        /// </summary>
        public string Format { get; set; }

        /// <summary>
        /// Дата издания
        /// </summary>
        public int Year { get; set; }
        /// <summary>
        /// Путь к архиву
        /// </summary>
        public string ArchivePath { get; set; }
        /// <summary>
        /// Индекс в архиве
        /// </summary>
        public int ArchiveIndex { get; set; }

    }
}
